import pytest

from days.day_17 import change_state, count_active_neighbours, boot_cycle, parse_pocket


def test_parse_pocket():
    input_pocket = [
        '.#.',
        '..#',
        '###'
    ]

    expected = {
        (0, 0, 0): '.', (1, 0, 0): '#', (2, 0, 0): '.',
        (0, 1, 0): '.', (1, 1, 0): '.', (2, 1, 0): '#',
        (0, 2, 0): '#', (1, 2, 0): '#', (2, 2, 0): '#',
    }

    actual = parse_pocket(input_pocket)

    assert actual == expected


@pytest.mark.parametrize('cube, expected', [
    ((0, 0, 0), 1),
    ((1, 1, 0), 5),
    ((1, 0, 0), 1),
    ((2, 1, 0), 3),
])
def test_count_active_neighbours(cube, expected):
    state = {
        (0, 0, 0): '.', (1, 0, 0): '#', (2, 0, 0): '.',
        (0, 1, 0): '.', (1, 1, 0): '.', (2, 1, 0): '#',
        (0, 2, 0): '#', (1, 2, 0): '#', (2, 2, 0): '#',
    }

    actual = count_active_neighbours(cube, state)

    assert actual == expected


@pytest.mark.parametrize('cube, expected', [
    ((0, 0, 0), '.'),
    ((1, 1, 0), '.'),
    ((1, 0, 0), '.'),
    ((2, 1, 0), '#'),
])
def test_change_state(cube, expected):
    state = {
        (0, 0, 0): '.', (1, 0, 0): '#', (2, 0, 0): '.',
        (0, 1, 0): '.', (1, 1, 0): '.', (2, 1, 0): '#',
        (0, 2, 0): '#', (1, 2, 0): '#', (2, 2, 0): '#',
    }

    actual = change_state(cube, state)

    assert actual == expected


def test_boot_cycle():
    state = {
        (0, 0, 0): '.', (1, 0, 0): '#', (2, 0, 0): '.',
        (0, 1, 0): '.', (1, 1, 0): '.', (2, 1, 0): '#',
        (0, 2, 0): '#', (1, 2, 0): '#', (2, 2, 0): '#',
    }

    expected = {
        (-1, -1, -1): '.', (0, -1, -1): '.', (1, -1, -1): '.', (2, -1, -1): '.', (3, -1, -1): '.',
        (-1, 0, -1): '.', (0, 0, -1): '.', (1, 0, -1): '.', (2, 0, -1): '.', (3, 0, -1): '.',
        (-1, 1, -1): '.', (0, 1, -1): '#', (1, 1, -1): '.', (2, 1, -1): '.', (3, 1, -1): '.',
        (-1, 2, -1): '.', (0, 2, -1): '.', (1, 2, -1): '.', (2, 2, -1): '#', (3, 2, -1): '.',
        (-1, 3, -1): '.', (0, 3, -1): '.', (1, 3, -1): '#', (2, 3, -1): '.', (3, 3, -1): '.',

        (-1, -1, 0): '.', (0, -1, 0): '.', (1, -1, 0): '.', (2, -1, 0): '.', (3, -1, 0): '.',
        (-1, 0, 0): '.', (0, 0, 0): '.', (1, 0, 0): '.', (2, 0, 0): '.', (3, 0, 0): '.',
        (-1, 1, 0): '.', (0, 1, 0): '#', (1, 1, 0): '.', (2, 1, 0): '#', (3, 1, 0): '.',
        (-1, 2, 0): '.', (0, 2, 0): '.', (1, 2, 0): '#', (2, 2, 0): '#', (3, 2, 0): '.',
        (-1, 3, 0): '.', (0, 3, 0): '.', (1, 3, 0): '#', (2, 3, 0): '.', (3, 3, 0): '.',

        (-1, -1, 1): '.', (0, -1, 1): '.', (1, -1, 1): '.', (2, -1, 1): '.', (3, -1, 1): '.',
        (-1, 0, 1): '.', (0, 0, 1): '.', (1, 0, 1): '.', (2, 0, 1): '.', (3, 0, 1): '.',
        (-1, 1, 1): '.', (0, 1, 1): '#', (1, 1, 1): '.', (2, 1, 1): '.', (3, 1, 1): '.',
        (-1, 2, 1): '.', (0, 2, 1): '.', (1, 2, 1): '.', (2, 2, 1): '#', (3, 2, 1): '.',
        (-1, 3, 1): '.', (0, 3, 1): '.', (1, 3, 1): '#', (2, 3, 1): '.', (3, 3, 1): '.'
    }

    actual = boot_cycle(state)

    assert actual == expected
